
#include "stdio.h"
#include "stdlib.h"
#include "stdint.h"

#include "gf16.h"

static
int byte_fdump(FILE * fp, const char * extra_msg , const unsigned char *v, unsigned n_byte)
{
    int r = 0;
    int t = fprintf( fp , "const unsigned char %s[%d] __attribute__((aligned(32))) = {\n", extra_msg , n_byte );
    if( 0 > t ) return t;
    else r += t;

    for(unsigned i=0;i<n_byte;i++) {
        int t = fprintf( fp , "0x%02x", v[i] );
        if( 0 > t ) return t;
        else r += t;

        if( i==n_byte-1 ) { r += fprintf( fp , "\n};\n\n"); break; }

        if(i%32 == 31 ) r += fprintf( fp , ",\n");
        else if(i%8 == 7) r += fprintf( fp , ", " );
        else r += fprintf( fp , "," );
    }
    return r;
}




//////////////////////////////////




static
int gen_gf256_mulbase_avx( unsigned char *multab )
{

    for(int i=0;i<4;i++) {
        for(int j=0;j<16;j++) multab[i*32*2+j]    = gf256_mul( 1<<i , j );
        for(int j=0;j<16;j++) multab[i*32*2+16+j] = gf256_mul( 1<<(i+4) , j );
        for(int j=0;j<16;j++) multab[i*32*2+32+j] = gf256_mul( 1<<i , j<<4 );
        for(int j=0;j<16;j++) multab[i*32*2+48+j] = gf256_mul( 1<<(i+4) , j<<4 );
    }

    return 16*4*4;
}




int main()
{
    fprintf( stdout , "// Contents are generated by %s.\n\n" , __FILE__ );
    fprintf( stdout , "#include \"gf256_tabs.h\"\n\n" );

    unsigned char gf256_mulbase_avx[16*4*4];
    gen_gf256_mulbase_avx( gf256_mulbase_avx );
    byte_fdump( stdout , "__gf256_mulbase_avx" , gf256_mulbase_avx , sizeof(gf256_mulbase_avx) );




    return 0;
}


